<script>
export default {
    props: {
        'selectID': String,
        'selectName': String,
        'options': Array
    },
    emits: ['update:selectedOption'],
    data() {
        return {
            selectedOption: null
        }
    },
    /******************************
     * The watch key is used to monitor the value of props and/or data. You define a function that is executed every time the watched variable with the old value and new value as parameters.
     ******************************/
    // Here it is a bit messy how we emit the value (watch + @input) because select html tag seems to have some peculiarity or another reason...
    watch: {
        options: {
                handler(newOptions, oldOptions) {
                for (const opt of newOptions) {
                    if (opt.selected) {
                        this.$emit('update:selectedOption', opt.optionValue);
                    }
                }
            },
            deep: true,
            immediate:true
        }
    },
    async mounted() {
        // this.$emit('update:selectedOption', this.selectedOption);
        for (const opt of this.options) {
            if (opt.selected) {
                this.$emit('update:selectedOption', opt.optionValue);
            }
        }
    }
}
</script>

<!-- <template>
    <select class="form-control" :id="selectID" :name="selectName"
    v-model="selectedOption"
    @change="$emit('update:selectedOption', selectedOption)">
        <option v-for="option in options" :key="option['optionValue']" :value="option['optionValue']"
            :selected="option['selected']">{{ option['optionName'] }}</option>
    </select>
</template> -->

<template>
    <select class="form-control" :id="selectID" :name="selectName"
    @input="event => $emit('update:selectedOption', event.target.value)">
        <option v-for="option in options" :key="option['optionValue']" :value="option['optionValue']"
            :selected="option['selected']">{{ option['optionName'] }}</option>
    </select>
</template>